
%parameters
fix_thresh = 1.5;
target_thresh = 3;
fixpoint = 1;

%extract
TimeSequence = TrialRecord.User.TimeSequence;
TrialSequence = TrialRecord.User.TrialSequence;

%initial fixation
fix = SingleTarget(eye_);
fix.Target = fixpoint;
fix.Threshold = fix_thresh;
wthfix = WaitThenHold(fix); %see if fixation success is maintained
wthfix.WaitTime = 5000;
wthfix.HoldTime = 1;
scene_getfix = create_scene(wthfix,fixpoint);

% for the choice scene
mul = MultiTarget(eye_);
mul.Threshold = [fix_thresh;target_thresh;target_thresh];
mul.WaitTime = 100;
mul.HoldTime = 1;
mul.TurnOffUnchosen = false;

% This is the same as normal ImageChanger except CurrentImageNumber is
% accessible
img = ImageChangerMitch(null_);
img.DurationUnit = 'frame';
mglIDs = StimulusInfo.ID;
mglPOS = StimulusInfo.Position;
% load the stimuli into image changer.
numFlash =  size(TrialSequence,1);
IL = cell(numFlash,3);
for ii = 1:numFlash
    stimIDs = TrialSequence(ii,:);
    stimIDs(stimIDs<=1) = [];
    try
    IL(ii,:) = {mglIDs(stimIDs),mglPOS(stimIDs,:),TimeSequence(ii)};
    catch
        keyboard
    end
end
img.ImageList = IL;

correct_objid = 2;

run_scene(scene_getfix);
if wthfix.Success
    acqfix = 1;
        % Present the images until fixation is broken
        brokefix = NotAdapter(fix);
        saccade_or_end = OrAdapter(brokefix);
        saccade_or_end.add(img);
        scene_stim = create_scene(saccade_or_end,1);        
        run_scene(scene_stim);
        if ~fix.Success
            stoppedfix = 1;
        else
            stoppedfix = 0;
        end
%     end
    if stoppedfix
        %move to choice
        trial_over = 0;
    else
        %miss
        trial_over = 1;
        trialerror(5);
    end
else
    %no fixation
    acqfix = 0;
    correct_trial = 0;
    trial_over = 1;
    trialerror(4);
end
%% 
if acqfix && ~trial_over
    flash = img.CurrentImageNum;
    stim_ids = TrialSequence(flash,:);
    stim_ids = stim_ids(stim_ids>0);
    mul.Target = stim_ids;   % TaskObject 1-4
    choice_scene = create_scene(mul, stim_ids);   % TaskObject 1-4
    run_scene(choice_scene);
    if mul.Success
            switch mul.ChosenTarget
                case 1
                    %broke fix
                    trialerror(3);
                case correct_objid
                    %%%CRITICAL PART
                    %if reaction time is in range
                        %correct
                        trialerror(0);
                        goodmonkey(100);
                    %else 
                        %too fast: incorrect
                    %end
                    
                otherwise
                    %incorrect
                    trialerror(6)
                    
            end
    else
        %broke fix
        trialerror(3)
    end
end

blank = TimeCounter(null_);
blank.Duration = 0;
endscene = create_scene(blank);
run_scene(endscene); %clear the screen
