function [C,timingfile,userdefined_trialholder] = IRT_userloop(MLConfig,TrialRecord)

userdefined_trialholder = '';
timingfile = 'IRT.m';

stimSize_X = 300;
stimSize_Y = 300;
target_presentation_time = 500;
nontarget_presentation_time = 100;
maxtime = 5000;
meantime = 3000;
mintime = 1000;
pos = [ 5 , 5 ;...
       -5 ,-5];
persistent   timing_filename_returned C_persist n_nontarget
if isempty(timing_filename_returned) 
    timing_filename_returned = true;
    
    C_persist = struct;
    C_persist(1).Type = 'sqr';
    C_persist(1).Xsize = 0.5;      % visual angle
    C_persist(1).Ysize = 0.5;      % visual angle
    C_persist(1).Color = [1 1 1];
    C_persist(1).FillFlag = 1;
    C_persist(1).Xpos = 0;
    C_persist(1).Ypos = 0;
    
    C_persist(2).Type = 'pic';
    C_persist(2).Name = 'star.jpg';
    C_persist(2).Xpos = pos(1,1);
    C_persist(2).Ypos = pos(1,2);
    C_persist(2).Xsize = stimSize_X;
    C_persist(2).Ysize = stimSize_Y;
    
    ii = 3;
    fnames = dir('*.BMP');
    for posi = 1:2
        for f = 1:length(fnames)
            C_persist(ii).Type = 'pic';
            C_persist(ii).Name = fnames(f).name;
            C_persist(ii).Xsize = stimSize_X;
            C_persist(ii).Ysize = stimSize_Y;
            C_persist(ii).Xpos = pos(posi,1);
            C_persist(ii).Ypos = pos(posi,2);
            ii = ii+1;
        end
    end
    n_nontarget = (ii-3)/2;
end


targetTime = round(exprnd(meantime),-2);
while targetTime>maxtime||targetTime<mintime
    targetTime = round(exprnd(meantime),-2);
end

nstim = ceil([maxtime/nontarget_presentation_time]);
sequence = randi(n_nontarget,nstim,1);
sequence1 = sequence+2;
sequence2 = sequence+2+n_nontarget;

target_ind = round(targetTime/nontarget_presentation_time);
sequence1(target_ind) = 2;

sequencefix = ones(size(sequence));
TimeSequence = sequencefix*nontarget_presentation_time;
TimeSequence(target_ind) = target_presentation_time;
TimeSequence = round(TimeSequence/(1000/MLConfig.Screen.RefreshRate));%hz
TrialSequence = [sequencefix,sequence1,sequence2];

TrialRecord.User.TimeSequence = TimeSequence;
TrialRecord.User.TrialSequence = TrialSequence;
C = C_persist;